package com.company.fragevent.screen.newentity;

import com.company.fragevent.screen.newfragment.NewFragment;
import io.jmix.core.LoadContext;
import io.jmix.core.SaveContext;
import io.jmix.ui.Notifications;
import io.jmix.ui.screen.*;
import com.company.fragevent.entity.NewEntity;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Collections;
import java.util.Set;

@UiController("frgevt_NewEntity.edit")
@UiDescriptor("new-entity-edit.xml")
@EditedEntityContainer("newEntityDc")
public class NewEntityEdit extends StandardEditor<NewEntity> {

    @Install(to = "newEntityDl", target = Target.DATA_LOADER)
    private NewEntity newEntityDlLoadDelegate(LoadContext<NewEntity> loadContext) {
        // Here you can load entity from an external store by ID passed in LoadContext
        return getEditedEntity();
    }

    @Install(target = Target.DATA_CONTEXT)
    private Set<Object> commitDelegate(SaveContext saveContext) {
        // Here you can save the edited entity or the whole SaveContext in an external store.
        // Return the set of saved instances.
        return Collections.singleton(getEditedEntity());
    }

    @Autowired
    private Notifications notifications;

    @Subscribe(id = "nameFragment", target = Target.CONTROLLER)
    protected void onBusinessHourValueChange(NewFragment.FragmentChangeEvent event) {
        var eventContent = event.getEventContent();
        notifications.create(Notifications.NotificationType.HUMANIZED)
                .withCaption(eventContent.getName())
                .show();
    }
}