package com.company.fragevent.screen.newfragment;

import com.company.fragevent.entity.NewEntity;
import io.jmix.core.Metadata;
import io.jmix.core.common.event.Subscription;
import io.jmix.ui.component.HasValue;
import io.jmix.ui.screen.ScreenFragment;
import io.jmix.ui.screen.Subscribe;
import io.jmix.ui.screen.UiController;
import io.jmix.ui.screen.UiDescriptor;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.EventObject;
import java.util.function.Consumer;

@UiController("frgevt_NewFragment")
@UiDescriptor("new-fragment.xml")
public class NewFragment extends ScreenFragment {

    @Autowired
    private Metadata metadata;

    public Subscription addChangeListener(Consumer<FragmentChangeEvent> listener) {
        return getEventHub().subscribe(FragmentChangeEvent.class, listener);
    }

    public static class FragmentChangeEvent extends EventObject {

        final private NewEntity eventContent;

        /**
         * Constructs a prototypical Event.
         *
         * @param source the object on which the Event initially occurred
         * @throws IllegalArgumentException if source is null
         */
        public FragmentChangeEvent(Object source, NewEntity eventContent) {
            super(source);
            this.eventContent = eventContent;
        }

        public NewEntity getEventContent() {
            return eventContent;
        }
    }

    @Subscribe("testField")
    public void onTestFieldValueChange(final HasValue.ValueChangeEvent event) {
        var entity = metadata.create(NewEntity.class);
        entity.setName("test event");
        fireEvent(FragmentChangeEvent.class, new FragmentChangeEvent(this,entity));
    }

    public void addAnyNewCodeHereToTriggerHotDeploy(){
        int i = 0;
        int j = 1;
        i++;
    }
}